import React from 'react';

import type { GeneralSizeProp } from '@/mui/types';

import { createClipSelector } from '@/modules/feeds/Editor/redux/selectors';
import { setAction } from '@/modules/feeds/Editor/redux/slices';

import { useFormSettings } from '@/modules/@common/Form';
import { useAppDispatch, useAppSelector } from '@/modules/@common/store/hooks';
import { Switch } from '@/mui/components';

type PropTypes = {
  disabled?: boolean;
};

function CreateClipSelector({ disabled = false }: PropTypes) {
  const dispatch = useAppDispatch();
  const { size } = useFormSettings();

  const createClip = useAppSelector(createClipSelector);

  return (
    <Switch
      data-id="createClip"
      size={size as GeneralSizeProp}
      color="primary"
      checked={createClip}
      disabled={disabled}
      onChange={(e) => dispatch(setAction({ createClip: e.target.checked }))}
    />
  );
}

export default CreateClipSelector;
